class Point
	def initialize(x, y)
		@x = x
		@y = y
	end

	def to_s
		return "(" + @x.to_s + "," + @y.to_s + ")"
	end

	# accessors: get methods
	def x
		@x
	end

	def y
		@y
	end

	# set methods
	def x=(val)
		@x = val
	end

	def y=(val)
		@y = val
	end

	# Overloaded operators are just methods
	def *(scalar)
		d = dup
		d.x *= scalar
		d.y *= scalar
		return d
	end
end

p = Point.new(1,0)
puts p

p.y += 10
puts p

q = p * 2
puts q
puts p     # p will not have changed
