def compare(x,y)
	if x.is_a? String
		puts "Comparing '#{x}' and '#{y}':"
	else
		puts "Comparing #{x} and #{y}:"
	end

	puts "\t ==      :  #{x == y}"
	puts "\t .equal? :  #{x.equal? y}"
	puts "\t <=>     :  #{x <=> y}"
	print "\n"
end

compare(1,1)
compare(1.0,1)
compare(1/4,0.25)
compare("a", "a")
compare("A", "a")


x = "same string"
y = x
compare(x,y)

y[0,4] = "changed"
puts y
compare(x,y)

x = y.dup
compare(x,y)

x[x.length,0] = ", again"
compare(x,y)
